/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: 7859_PLAFUNS_TIPO_RECEITA_UTILIZADA.SQL

Descrio:
Funo para retornar a receita utiliza do prato.

'S' - Receita por Servio
'F' - Receita Local
'P' - Receita Padro

Criao:
16/11/2011 - Samuel Anderson
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'RECEITA_UTILIZADA'  AND
	        TYPE = 'FN'                        AND
	        U.UID = O.UID                     AND
	        U.NAME = USER
          )
  DROP FUNCTION RECEITA_UTILIZADA
  GO

CREATE FUNCTION RECEITA_UTILIZADA(
   @P_CDPRATO      VARCHAR(10),
   @P_CDFILAUXPRAT VARCHAR(4),
   @P_CDFILIAL     VARCHAR(4),
   @P_CDSERVFILI   VARCHAR(5)) RETURNS VARCHAR
AS
BEGIN

   DECLARE @V_IDTIPO     VARCHAR(1);

   SELECT DISTINCT @V_IDTIPO = IDTIPO
   FROM(SELECT 'S' AS IDTIPO
        FROM RECESERV
        WHERE (RECESERV.CDFILAUXPRAT  = @P_CDFILAUXPRAT)
           AND (RECESERV.CDPRATO      = @P_CDPRATO)
           AND (RECESERV.CDFILIAL     = @P_CDFILIAL)
           AND (RECESERV.CDSERVFILI   = @P_CDSERVFILI)
	UNION ALL
           SELECT 'F' AS IDTIPO
             FROM RECEFILI
            WHERE (RECEFILI.CDFILAUXPRAT = @P_CDFILAUXPRAT)
              AND (RECEFILI.CDPRATO      = @P_CDPRATO)
              AND (RECEFILI.CDFILIAL     = @P_CDFILIAL)
              AND NOT EXISTS (SELECT CDPRATO
                                FROM RECESERV
                               WHERE (CDFILAUXPRAT = @P_CDFILAUXPRAT)
                                 AND (CDPRATO      = @P_CDPRATO)
                                 AND (CDFILIAL     = @P_CDFILIAL)
                                 AND (CDSERVFILI   = @P_CDSERVFILI))
          UNION ALL
           SELECT 'P' AS IDTIPO
             FROM RECEPADR
            WHERE (RECEPADR.CDFILAUXPRAT = @P_CDFILAUXPRAT)
              AND (RECEPADR.CDPRATO      = @P_CDPRATO)
              AND NOT EXISTS (SELECT CDPRATO
                                FROM RECEFILI
                               WHERE (CDFILAUXPRAT = @P_CDFILAUXPRAT)
                                 AND (CDPRATO      = @P_CDPRATO)
                                 AND (CDFILIAL     = @P_CDFILIAL))
              AND NOT EXISTS (SELECT CDPRATO
                                FROM RECESERV
                               WHERE (CDFILAUXPRAT = @P_CDFILAUXPRAT)
                                 AND (CDPRATO      = @P_CDPRATO)
                                 AND (CDFILIAL     = @P_CDFILIAL)
                                 AND (CDSERVFILI   = @P_CDSERVFILI))) A;
   RETURN(@V_IDTIPO);
END;
GO